-- Just for funzies, names of integers

module Numerals where

import List (intersperse)

numeral :: Integer -> String

numeral n | n < 0 = "negative " ++ numeral (-n)

numeral n | n < 20 = numNames !! fromInteger n

numeral n | n < 100 = g (tensNames !! fromInteger q) r
 where
   (q,r)     = n `divMod` 10
   g tname 0 = tname
   g tname m = tname ++ " " ++ numeral m

numeral n | n < 1000 = g (numeral q ++ " hundred") r
 where
   (q,r) = n `divMod` 100
   g hname 0 = hname
   g hname m = hname ++ " " ++ numeral m

numeral n = concat $
            intersperse ", " $
            reverse $
            filter (not.null) $
            zipWith g (rems 1000 n) thousandNames
 where
   g 0 _    = ""
   g m name = numeral m ++ " " ++ name

rems :: Integer -> Integer -> [Integer]
rems base 0 = []
rems base n = r : rems base q where (q,r) = quotRem n base

numNames = ["zero", "one", "two", "three", "four", "five", "six",
            "seven", "eight", "nine", "ten", "eleven", "twelve",
            "thirteen", "fourteen", "fifteen", "sixteen", "seventeen",
            "eighteen", "nineteen"]

tensNames = ["", "ten", "twenty", "thirty", "forty", "fifty", "sixty", "seventy",
             "eighty", "ninety"]

thousandNames = "" : "thousand" : map (++ "illion") illionPrefixes

illionPrefixes = [ "m", "b", "tr", "quadr", "quint"
                 , "sext", "sept", "oct", "non", "dec"] ++ repeat "dunno-"