-- Simple procedural geometry example, reverse-engineered from the D3D
-- sample shader Ripple.vsh, used in the D3D "VertexShader" sample.

module Ripple where

import Vertigo

ripple :: Anim (Vec2E -> (Vec3E,ColorE))
ripple t p = (p',col)
 where
   theta = 25 * magnitude p * sin t
   col   = gray ((1 - cos theta)/2)
   p'    = 2.5 *^
           vec3 u (sin theta / 20) v
            where (u,v) = coords p

-- main = compileAnim (const ripple)
